using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Text.RegularExpressions;
using System.Data;

namespace QASharp
{
	/// <summary>
	/// Summary description for frmQueryWriter.
	/// </summary>
	public class frmQueryWriter : System.Windows.Forms.Form
	{
		public  DBControls.FlickerFreeRichEditTextBox rtbQueryPad;
		private System.Windows.Forms.Panel pnlQuery;
		public  System.Windows.Forms.DataGrid dgResult;
		private System.Windows.Forms.Splitter splitter1;
		private System.ComponentModel.Container components = null;
		private System.Windows.Forms.TabControl tabResult;
		private System.Windows.Forms.TabPage tabPage0;
		
		private static int buttonIndex=0;

		ListBox lstIntellisense = new ListBox();

		// add the keywords in this array to highlight it
		String [] keywords = 
			{ "select", "insert", "update","create", "delete",
			  "where", "group", "by", "rollup","cube", "as","inner", "join",
			  "right","left","into","from","go","procedure",
			  "function","view", "top", "as","count","case"
			}; 
		
		int BUTTON_LEFT_DELTA  = 72;		
		int BUTTON_LEFT_CONST  = 72;


		public frmQueryWriter()
		{
			InitializeComponent();
			this.Controls.Add(lstIntellisense);
			lstIntellisense.KeyDown += new System.Windows.Forms.KeyEventHandler(this.lstIntellisense_KeyDown);
			lstIntellisense.SelectedIndexChanged += new System.EventHandler(this.lstIntellisense_SelectedIndexChanged);
			//lstIntellisense.DoubleClick += new System.EventHandler(this.lstIntellisense_DoubleClick);
			lstIntellisense.Items.Add("Customers");
			lstIntellisense.Items.Add("Orders");
			lstIntellisense.Visible = false;
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if(components != null)
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			System.Resources.ResourceManager resources = new System.Resources.ResourceManager(typeof(frmQueryWriter));
			this.pnlQuery = new System.Windows.Forms.Panel();
			this.rtbQueryPad = new DBControls.FlickerFreeRichEditTextBox();
			this.dgResult = new System.Windows.Forms.DataGrid();
			this.splitter1 = new System.Windows.Forms.Splitter();
			this.tabResult = new System.Windows.Forms.TabControl();
			this.tabPage0 = new System.Windows.Forms.TabPage();
			this.pnlQuery.SuspendLayout();
			((System.ComponentModel.ISupportInitialize)(this.dgResult)).BeginInit();
			this.tabResult.SuspendLayout();
			this.tabPage0.SuspendLayout();
			this.SuspendLayout();
			// 
			// pnlQuery
			// 
			this.pnlQuery.Anchor = (((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom) 
				| System.Windows.Forms.AnchorStyles.Left) 
				| System.Windows.Forms.AnchorStyles.Right);
			this.pnlQuery.BorderStyle = System.Windows.Forms.BorderStyle.Fixed3D;
			this.pnlQuery.Controls.AddRange(new System.Windows.Forms.Control[] {
																				   this.rtbQueryPad});
			this.pnlQuery.Name = "pnlQuery";
			this.pnlQuery.Size = new System.Drawing.Size(768, 296);
			this.pnlQuery.TabIndex = 0;
			// 
			// rtbQueryPad
			// 
			this.rtbQueryPad.AcceptsTab = true;
			this.rtbQueryPad.Dock = System.Windows.Forms.DockStyle.Fill;
			this.rtbQueryPad.Name = "rtbQueryPad";
			this.rtbQueryPad.Size = new System.Drawing.Size(764, 292);
			this.rtbQueryPad.TabIndex = 2;
			this.rtbQueryPad.Text = "";
			//this.rtbQueryPad.KeyDown += new System.Windows.Forms.KeyEventHandler(this.rtbQueryPad_KeyDown);
			this.rtbQueryPad.TextChanged += new System.EventHandler(this.rtbQueryPad_TextChanged);
			// 
			// dgResult
			// 
			this.dgResult.DataMember = "";
			this.dgResult.Dock = System.Windows.Forms.DockStyle.Fill;
			this.dgResult.HeaderForeColor = System.Drawing.SystemColors.ControlText;
			this.dgResult.Name = "dgResult";
			this.dgResult.Size = new System.Drawing.Size(760, 230);
			this.dgResult.TabIndex = 6;
			// 
			// splitter1
			// 
			this.splitter1.Dock = System.Windows.Forms.DockStyle.Bottom;
			this.splitter1.Location = new System.Drawing.Point(0, 562);
			this.splitter1.Name = "splitter1";
			this.splitter1.Size = new System.Drawing.Size(768, 3);
			this.splitter1.TabIndex = 7;
			this.splitter1.TabStop = false;
			// 
			// tabResult
			// 
			this.tabResult.Controls.AddRange(new System.Windows.Forms.Control[] {
																					this.tabPage0});
			this.tabResult.Dock = System.Windows.Forms.DockStyle.Bottom;
			this.tabResult.Location = new System.Drawing.Point(0, 306);
			this.tabResult.Name = "tabResult";
			this.tabResult.SelectedIndex = 0;
			this.tabResult.Size = new System.Drawing.Size(768, 256);
			this.tabResult.TabIndex = 1;
			// 
			// tabPage0
			// 
			this.tabPage0.Controls.AddRange(new System.Windows.Forms.Control[] {
																				   this.dgResult});
			this.tabPage0.Location = new System.Drawing.Point(4, 22);
			this.tabPage0.Name = "tabPage0";
			this.tabPage0.Size = new System.Drawing.Size(760, 230);
			this.tabPage0.TabIndex = 0;
			this.tabPage0.Text = "Result 0";
			// 
			// frmQueryWriter
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(768, 565);
			this.Controls.AddRange(new System.Windows.Forms.Control[] {
																		  this.tabResult,
																		  this.splitter1,
																		  this.pnlQuery});
			this.Icon = ((System.Drawing.Icon)(resources.GetObject("$this.Icon")));
			this.KeyPreview = true;
			this.Name = "frmQueryWriter";
			this.Text = "Query Writer";
			this.WindowState = System.Windows.Forms.FormWindowState.Maximized;
			this.KeyDown += new System.Windows.Forms.KeyEventHandler(this.frmQueryWriter_KeyDown);
			this.Load += new System.EventHandler(this.frmQueryWriter_Load);
			this.pnlQuery.ResumeLayout(false);
			((System.ComponentModel.ISupportInitialize)(this.dgResult)).EndInit();
			this.tabResult.ResumeLayout(false);
			this.tabPage0.ResumeLayout(false);
			this.ResumeLayout(false);

		}
		#endregion

		/// <summary>
		/// Creates dynamic grids in the output windows based on no. of queries
		/// </summary>
		/// <param name="dt">the datatable </param>
		public void  RenderGrid(DataTable dt)
		{
			
			if (buttonIndex == 0)	// 0 the query
			{
				this.dgResult.DataSource = dt;	
				buttonIndex++;
				return;
			}
			
			tabResult.Controls.Add(new TabPage("Result " + buttonIndex.ToString()));
			tabResult.TabPages[tabResult.TabPages.Count-1].Name = "tabPages"+ buttonIndex.ToString();

			CreateGridInTabControl(dt, "dgResult" + buttonIndex.ToString());
			buttonIndex++;
		}
		
		/// <summary>
		/// This code actually creates the grid control in the output window
		/// </summary>
		/// <param name="dt">the datatable </param>
		/// <param name="gridName">the grid name</param>
		public void CreateGridInTabControl(System.Data.DataTable dt, string gridName)
		{
			System.Windows.Forms.DataGrid dg = new System.Windows.Forms.DataGrid ();
			
			dg.Name		  =	 gridName;
			dg.DataSource = dt;
		
			dg.Top		  = dgResult.Top;
			dg.Left	      = dgResult.Left;
			dg.Anchor	  = dgResult.Anchor;
			dg.Dock		  = dgResult.Dock;
			dg.Width	  = dgResult.Width;
			dg.Height	  = dgResult.Height;

			tabResult.TabPages[tabResult.TabPages.Count-1].Controls.Add(dg);
		}

		public void ResetButtonIndex()
		{
			buttonIndex = 0;
			BUTTON_LEFT_DELTA = BUTTON_LEFT_CONST ;
		}
		
		//handler for Button click (result)
		// This function is not yet used
		private void btnTable0_Click(object sender, System.EventArgs e)
		{
			MessageBox.Show(((System.Windows.Forms.Button)(sender)).Tag.ToString());		

			DataGrid dg;
			dg = (DataGrid)GetControl(((System.Windows.Forms.Button)(sender)).Tag.ToString());

			if (null == dg)
			{}
			else
			{
				dg.BringToFront();
			}
		}

		
		public void DisposeTabPages()
		{
			foreach(TabPage tp in tabResult.TabPages)
			{
				if (tp.Name != "tabPage0")
				{
					tabResult.TabPages.Remove(tp);
				}
			}
		}
		
		// This function is not yet used 
		private Control GetControl(string controlName )
		{
			foreach  (Control grid in this.Controls)
			{
				if (null==grid) continue;
				
				if (grid.GetType().Name == "DataGrid")
				{
					if (grid.Name == controlName)
						return grid;
				}
			}
			return null;
		}

		private void frmQueryWriter_Load(object sender, System.EventArgs e)
		{
			
		}
		
		private void rtbQueryPad_TextChanged(object sender, System.EventArgs e)
		{
			// Split the line into tokens.
			Regex r = new Regex("([ \\t{}();])");
			if (rtbQueryPad.Text.Trim() =="")
				return;

			// Get current line
			int currentLine = rtbQueryPad.GetLineFromCharIndex(rtbQueryPad.GetCharIndexFromPosition(Cursor.Position));
			
			/// WHen large amount of text is copied, generates error
			
			try {
				string currentLineString = rtbQueryPad.Lines[currentLine];

				int startPos = 0;
				for (int i = 0; i < currentLine-1; i++)
				{
					startPos = startPos + rtbQueryPad.Lines[i].Length;
				}

				string [] tokens = r.Split(currentLineString);
				
				foreach (string token in tokens) 
	  			{
					if (token.Trim() != string.Empty) 
					{
						if (IsKeyWord(token))
							FindAndHighlight(token,Color.Blue,false,true,startPos);
						else
							FindAndHighlight(token,Color.Black,false,true,startPos);
					}
				}
			}
			catch (Exception ex)
			{
				Console.WriteLine(ex.Message);
			}
		} 

		private bool IsKeyWord(string input)
		{
			
			for (int i = 0; i < keywords.Length; i++) 
			{
				if (input.Trim().ToLower() == keywords[i].ToLower())
				{
					return true;
				}
			}
			return false;
		}
		
		/// <summary>
		/// Finds and highlighs the keywords
		/// </summary>
		/// <param name="SearchText"></param>
		/// <param name="HighlightColor"></param>
		/// <param name="MatchCase"></param>
		/// <param name="WholeWords"></param>
		/// 
		private void FindAndHighlight(string SearchText , Color HighlightColor, bool MatchCase ,bool WholeWords, int startPos )
		{

			int StartLooking = 0;
			int FoundAt ;
			int SearchLength; 
			
			int CurrentSelectionStart = rtbQueryPad.SelectionStart;
			int CurrentSelectionLength = rtbQueryPad.SelectionLength;

			RichTextBoxFinds RTBfinds; 

			if (SearchText == string.Empty) return;
        
			if (MatchCase && WholeWords) 
				RTBfinds = RichTextBoxFinds.MatchCase | RichTextBoxFinds.WholeWord;
			else	
				if (MatchCase)
				RTBfinds = RichTextBoxFinds.MatchCase;
			else				
				if (WholeWords)
				RTBfinds = RichTextBoxFinds.WholeWord;
			else		
				RTBfinds = RichTextBoxFinds.None;
			
			SearchLength = SearchText.Length;
			DBControls.FlickerFreeRichEditTextBox._Paint = false;

			StartLooking = startPos;
			do
			{
				try
				{
					FoundAt = rtbQueryPad.Find(SearchText, StartLooking, RTBfinds);
					
					if(FoundAt > -1)
						rtbQueryPad.SelectionColor = HighlightColor;
					
					StartLooking = StartLooking + SearchLength ;
				}
				catch(Exception ex)
				{
					System.Diagnostics.Debug.WriteLine(ex.Message);
					FoundAt = -1;
				}
			}while (FoundAt > -1);
			
			rtbQueryPad.SelectionStart = CurrentSelectionStart;
			rtbQueryPad.SelectionLength = 0;
			rtbQueryPad.SelectionColor = Color.Black;

			DBControls.FlickerFreeRichEditTextBox._Paint = true;

		}

		/*private void rtbQueryPad_KeyDown(object sender, System.Windows.Forms.KeyEventArgs e)
		{
			if (e.KeyCode == Keys.OemPeriod)
			{
				ShowIntellisense();
			}
			else if ( e.KeyCode == Keys.Up )
			{
				if ( this.lstIntellisense.Visible)
				{
					if ( this.lstIntellisense.SelectedIndex > 0 )
						this.lstIntellisense.SelectedIndex--;

					e.Handled = true;
				}
			}
			else if ( e.KeyCode == Keys.Down )
			{
				// The up key moves down our member list, if
				// the list is visible
				
				if ( this.lstIntellisense.Visible)
				{
					if ( this.lstIntellisense.SelectedIndex < this.lstIntellisense.Items.Count -1 )
						this.lstIntellisense.SelectedIndex++;

					e.Handled = true;
				}
			}
		}
		*/

		private void ShowIntellisense()
		{
			Point p =  rtbQueryPad.GetPositionFromCharIndex(rtbQueryPad.SelectionStart);
			p.X += 4;
			p.Y += (int) Math.Ceiling(this.rtbQueryPad.Font.GetHeight()) + 2;
			lstIntellisense.Location = p;
			lstIntellisense.BringToFront();
			lstIntellisense.Show();
		}

		private void frmQueryWriter_KeyDown(object sender, System.Windows.Forms.KeyEventArgs e)
		{
		}

		private void lstIntellisense_KeyDown(object sender, System.Windows.Forms.KeyEventArgs e)
		{
			// Ignore any keys being pressed on the listview
			this.rtbQueryPad.Focus();
		}
		private void lstIntellisense_SelectedIndexChanged(object sender, System.EventArgs e)
		{
			// Make sure when an item is selected, control is returned back to the richtext
			this.rtbQueryPad.Focus();
		}
	}
}

